%bcond_with dotests

%global __tar /opt/freeware/bin/tar

%global py_major 3.9

%global py_minor 16

%global python_major python%{py_major}

%global python3_sitearch %(%{python_major} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(0))")

Name:		ansible-core
Summary:	A radically simple IT automation system
Version:	2.14.2
Release:	1
License:	GPLv3+
Group:		Development/Libraries
Source0:	https://releases.ansible.com/ansible/%{name}-%{version}.tar.gz
Url:		https://ansible.com
BuildArch:	noarch

Prefix:/opt/freeware

BuildRequires:  %{python_major}-devel >= %{py_major}.%{py_minor}
BuildRequires:  %{python_major}-setuptools >= 65.2.0
Requires:       %{python_major} >= %{py_major}.%{py_minor}
Requires:       %{python_major}-jinja2 >= 3.0.3
Requires:       %{python_major}-pyyaml >= 5.4.1.1
Requires:       %{python_major}-cryptography >= 3.4.7
Requires:       %{python_major}-packaging >= 19.2
Requires:       %{python_major}-resolvelib >= 0.5.4
Requires:	(ansible >= 7.2.0 if ansible <= 2.9.25)

%description
Ansible is a radically simple model-driven configuration management,
multi-node deployment, and remote task execution system. Ansible works
over SSH and does not require any software or daemons to be installed
on remote nodes. Extension modules can be written in any language and
are transferred to managed machines automatically.

This is the base part of ansible (the engine).

%prep
%autosetup -p1 -n %{name}-%{version}

%build
export OBJECT_MODE=64
%{python_major} setup.py build


%install
[ -d "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%{python_major} setup.py install --skip-build --root ${RPM_BUILD_ROOT}


# Create system directories that Ansible defines as default locations in
# ansible/config/base.yml
DATADIR_LOCATIONS='%{_datadir}/ansible/collections
%{_datadir}/ansible/collections/ansible_collections
%{_datadir}/ansible/plugins/doc_fragments
%{_datadir}/ansible/plugins/action
%{_datadir}/ansible/plugins/become
%{_datadir}/ansible/plugins/cache
%{_datadir}/ansible/plugins/callback
%{_datadir}/ansible/plugins/cliconf
%{_datadir}/ansible/plugins/connection
%{_datadir}/ansible/plugins/filter
%{_datadir}/ansible/plugins/httpapi
%{_datadir}/ansible/plugins/inventory
%{_datadir}/ansible/plugins/lookup
%{_datadir}/ansible/plugins/modules
%{_datadir}/ansible/plugins/module_utils
%{_datadir}/ansible/plugins/netconf
%{_datadir}/ansible/roles
%{_datadir}/ansible/plugins/strategy
%{_datadir}/ansible/plugins/terminal
%{_datadir}/ansible/plugins/test
%{_datadir}/ansible/plugins/vars'

mkdir -p $RPM_BUILD_ROOT%{_datadir}/ansible/plugins/
for location in $DATADIR_LOCATIONS ; do
	mkdir $RPM_BUILD_ROOT"$location"
done
mkdir -p $RPM_BUILD_ROOT%{_prefix}/etc/ansible/
mkdir -p $RPM_BUILD_ROOT%{_prefix}/etc/ansible/roles/

cp examples/hosts $RPM_BUILD_ROOT%{_prefix}/etc/ansible/
cp examples/ansible.cfg $RPM_BUILD_ROOT%{_prefix}/etc/ansible/
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man1
cp -v docs/man/man1/*.1 $RPM_BUILD_ROOT/%{_mandir}/man1/


#create softlinks for config files 
( cd $RPM_BUILD_ROOT  # same as %{buildroot}

for dir in etc  
do
	mkdir -p $dir/ansible
	cd $dir/ansible
	ln -sf ../..%{_prefix}/$dir/ansible/* .
	cd -
done
)
	
%check
%if %{with dotests}

#export PYTHON=%{python_major}
#%{python_major} -m venv python_venv
#. ./python_venv/bin/activate
#pip3.9 install six==1.13.0
#pip3.9 install pyparsing==2.4.4
#pip3.9 install packaging==19.2
#make tests-py3
#deactivate

%endif

%post
echo "\n Ansible (2.14.0 onwards) requires the locale encoding to be UTF-8.\n For more information, please refer https://github.com/ansible/ansible/blob/stable-2.14/changelogs/CHANGELOG-v2.14.rst#id22 \n"

%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%license COPYING
%doc README.rst PKG-INFO changelogs/CHANGELOG-v2.14.rst
%doc %{_mandir}/man1/ansible*
%config(noreplace) %{_sysconfdir}/ansible/
/etc/ansible/*
%{_bindir}/ansible*
%{_datadir}/ansible/
%{python3_sitearch}/*

%changelog
* Fri Jul 21 2023 Reshma V Kumar <reskumar@in.ibm.com> - 2.14.2-1
- Initial port to AIX Toolbox
